#include "xsmodstr.h"

static DWORD str_info[2][3] = {
  /* EX:0002EFC0: FF -> 00 ; xor bl, 0FFh => 000h
     EX:0009E3FC-0009F854=5208 */
  {0x0002EFC0UL, 0x0009E3FCUL, 5208},
  /* PS:0002EB4B: FF -> 00 ; xor dl, 0FFh => 000h
     PS:0009CFF4-0009E65F=5739 */
  {0x0002EB4BUL, 0x0009CFF4UL, 5739}
};

/* static buffer to faster crypt/decrypt */
static BYTE str_buff[5740];

BYTE StrBlockState(int fl, int flags) {
BYTE state;
  state = 0xFF;
  if ((fl != -1) && ((flags & 3) == flags)) {
    /* read xor byte */
    lseek(fl, str_info[flags & 1][0], SEEK_SET);
    read(fl, &state, 1);
  }
  return(state);
}

/*
  fl - opened file handle for read/write
  flags:
    bit 0: 0 - exhumed; 1 - powerslave
    bit 1: 0 - crypt;   1 - decrypt
*/
void StrBlockDecrypt(int fl, int flags) {
WORD i, k;
BYTE b;
  /* sanity checks */
  if ((fl != -1) && (flags & 3) == flags) {
    for (k = 0; k < 2; k++) {
      /* read/write xor byte */
      lseek(fl, str_info[flags & 1][0], SEEK_SET);
      if (!k) {
        read(fl, &b, 1);
      } else {
        b = (flags & 2) ? 0x00 : 0xFF;
        write(fl, &b, 1);
      }
      /* read/write buffer */
      lseek(fl, str_info[flags & 1][1], SEEK_SET);
      if (!k) {
        read(fl, str_buff, (size_t) str_info[flags & 1][2]);
      }
      /* decrypt/crypt */
      for (i = 0; i < str_info[flags & 1][2]; i++) {
        str_buff[i] ^= str_buff[i] ? b : 0x00;
      }
      if (k) {
        write(fl, str_buff, (size_t) str_info[flags & 1][2]);
      }
    }
  }
}
