#include "xsmodvoc.h"

/* v1.5 */
static char strWasp[] = "WASP_WNG.VOC";
#define VOC_SIZE 48
static BYTE voc_data[VOC_SIZE] = {
  0x43, 0x72, 0x65, 0x61, 0x74, 0x69, 0x76, 0x65, 0x20, 0x56, 0x6F, 0x69, 0x63, 0x65, 0x20, 0x46,
  0x69, 0x6C, 0x65, 0x1A, 0x1A, 0x00, 0x14, 0x01, 0x1F, 0x11, 0x09, 0x11, 0x00, 0x00, 0x11, 0x2B,
  0x00, 0x00, 0x08, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00
};

/* v1.5 */
void BuildVoiceStub(int state) {
int fl;
  if (state) {
    /* if there is any other file already exists - do not overwrite it */
    if (!FileExists(strWasp, 0)) {
      fl = open(strWasp, O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
      if (fl != -1) {
        write(fl, voc_data, VOC_SIZE);
        close(fl);
      }
    }
  } else {
    /* remove only our stub file (checked by size) - do not remove anything else */
    if (FileExists(strWasp, VOC_SIZE)) {
      remove(strWasp);
    }
  }
}
